// Generated by dts-bundle v0.7.3

declare module 'decoratory' {
    export * from "decoratory/decorators/deprecated";
    export * from "decoratory/decorators/observe";
    export * from "decoratory/decorators/readonly";
}

declare module 'decoratory/decorators/deprecated' {
    type DeprecationMessage = string;
    /**
        * Mark a function as deprecated. This prints deprecation warnings to the console, when the deprecated function is called.
        */
    export function Deprecated(target: unknown, propertyKey: string | symbol, descriptor: PropertyDescriptor): PropertyDescriptor;
    /**
        * Mark a function as deprecated with a custom deprecation message.
        * @param message custom deprecation message
        */
    export function Deprecated(message?: DeprecationMessage): MethodDecorator;
    export {};
}

declare module 'decoratory/decorators/observe' {
    type ObserverCallback<T> = (value: T) => unknown;
    /**
        * Observe all changes of a property. All assignments will be logged to the console.
        */
    export function Observe(target: object, propertyKey: string | symbol): void;
    /**
        * Observe all changes of a property and invoke a provided callback on each assignment.
        * @param cb callback to execute on assignment of observed variable
        */
    export function Observe<T>(cb: ObserverCallback<T>): PropertyDecorator;
    export {};
}

declare module 'decoratory/decorators/readonly' {
    /**
      * Make a property readonly. This means, that it can only be assigned once. Attempts to reassign this property will lead to a TypeError at runtime.
      */
    export const Readonly: PropertyDecorator;
}

